let Genode = env:DHALL_GENODE

let XML = Genode.Prelude.XML

let service = λ(s : Text) → { service = s, label = None Text }

in  { indexInfo =
        "Desktop backdrop image"
    , runtime =
          Genode.Runtime.defaults
        ⫽ { resources =
              { ram = Genode.units.MiB 8, caps = 96 }
          , binary =
              "backdrop"
          , requires =
              [ service "nitpicker" ]
          , roms =
              [ "backdrop"
              , "backdrop.png"
              , "libc.lib.so"
              , "libm.lib.so"
              , "libpng.lib.so"
              , "vfs.lib.so"
              , "zlib.lib.so"
              ]
          , config =
              XML.text
              ''
              <config>
              	<libc/>
              	<vfs> <rom name="backdrop.png"/> </vfs>
              	<image png="backdrop.png" scale="zoom"/>
              </config>
                          ''
          }
    }
