let Genode = env:DHALL_GENODE

let Prelude = Genode.Prelude

let XML = Prelude.XML

let service = λ(s : Text) → { service = s, label = None Text }

let serviceLabel = λ(s : Text) → λ(l : Text) → { service = s, label = Some l }

in  { indexInfo =
        "Nitpicker input event debugger"
    , runtime =
          Genode.Runtime.defaults
        ⫽ { ram =
              Genode.units.MiB 12
          , caps =
              256
          , binary =
              "show_input"
          , requires =
              [ serviceLabel "fs" "fonts", service "nitpicker" ]
          , roms =
              [ "show_input", "vfs.lib.so" ]
          , config =
              XML.text
              ''
              	<config>
              		<vfs>
              			<dir name="fonts">
              				<fs label="fonts"/>
              			</dir>
              		</vfs>
              	</config>
              
              ''
          }
    }
